#!/usr/bin/env python

import os
from wxPython.wx import *
from wxPython import *
from wxPython.html import *
import codecs
import readdic

# Menu constants
ID_EXIT=101
ID_OPTION=201
ID_REFRESH=301
ID_ABOUT=401

projectName = "pyDic"
fontsl = [
			[4, 5, 6, 8, 9, 10, 12],
			[5, 6, 8, 9, 10, 12, 16],
			[6, 8, 9, 10, 12, 16, 20],
			[8, 9, 10, 12, 16, 20, 22],
			[9, 10, 12, 16, 20, 22, 26],
			[10, 12, 16, 20, 22, 26, 30],
			[12, 16, 20, 22, 26, 30, 32]
		]

u = lambda str="", encode="euc-kr":unicode(str, encode)

class MainWindow(wxFrame):
	def __init__(self, parent, id, title):
		wxFrame.__init__(self, parent, -1, title, size=(600, 480),
				style=wxDEFAULT_FRAME_STYLE|wxNO_FULL_REPAINT_ON_RESIZE)

		""" о κ ߰"""
		self.sampleList = ['aaa', 'bbb'] #FIXME
		self.wordDic = {}
		self.wordList = []
		f = self.GetFont() #FIXME

		self.word_text = wxTextCtrl(self, 20, "", wxPoint(-1, -1), wxSize(150, -1), style=wxTE_PROCESS_ENTER)
		#self.dic_combo = wxComboBox(self, -1, "", wxPoint(-1, -1), wxSize(-1, -1), self.sampleList, wxCB_DROPDOWN)
		#self.word_list = wxListBox(self, -1, wxPoint(-1, -1), wxSize(-1, -1), self.wordList, style=wxLB_SINGLE|wxLB_NEEDED_SB|wxLB_SORT)
		#self.meaning_html = wxTextCtrl(self, -1, "", wxPoint(-1, -1), wxSize(-1, -1), style=wxTE_MULTILINE|wxTE_READONLY|wxTE_RICH)
		self.meaning_html = wxHtmlWindow(self, -1)
		self.meaning_html.SetFonts(f.GetFaceName(), f.GetFaceName(), fontsl[2])

		#self.boxh = wxBoxSizer(wxHORIZONTAL)
		#self.boxh.Add(self.word_text, 0, wxEXPAND)
		#self.boxh.Add(self.dic_combo, 0, wxEXPAND)
		
		self.boxv = wxBoxSizer(wxVERTICAL)
		#self.boxv.Add(self.boxh, 0, wxEXPAND)
		self.boxv.Add(self.word_text, 0, wxEXPAND)
		self.boxv.Add(self.meaning_html, 1, wxEXPAND)

		self.sizer = self.boxv
		self.SetAutoLayout(True)
		self.SetSizer(self.sizer)
		#self.sizer.Fit(self)

		self.CreateStatusBar()
		filemenu = wxMenu()
		editmenu = wxMenu()
		viewmenu = wxMenu()
		helpmenu = wxMenu()
		filemenu.Append(ID_EXIT, u("(&X)"), u(projectName + " մϴ."))
		editmenu.Append(ID_OPTION, u("ȯ漳(&O)..."), u(projectName + " ȯ մϴ."))
		#viewmenu.Append(ID_REFRESH, u("ܾ ٽ Ѹ(&R)"), u("ܾ Ͽ ٽ о ȭ鿡 ѷݴϴ.."))
		helpmenu.Append(ID_ABOUT, u(projectName + " Ͽ(&A)"), u(projectName + "  ҰԴϴ."))

		menuBar = wxMenuBar()
		menuBar.Append(filemenu, u("(&F)"))
		menuBar.Append(editmenu, u("(&E)"))
		#menuBar.Append(viewmenu, u("(&V)"))
		menuBar.Append(helpmenu, u("(&H)"))

		self.SetMenuBar(menuBar)

		#޴ ̺Ʈ
		EVT_MENU(self, ID_EXIT, self.OnExit)
		EVT_MENU(self, ID_OPTION, self.OnOption)
		EVT_MENU(self, ID_REFRESH, self.OnRefresh)
		EVT_MENU(self, ID_ABOUT, self.OnAbout)
		
		#Ʈ ̺Ʈ
		EVT_TEXT(self, 20, self.OnText)
		EVT_TEXT_ENTER(self, 20, self.OnTextEnter)

		self.dicfile = self.openDic("/usr/share/ldic/dic/engkor.dic")
		self.Show(True)
		self.word_text.SetFocus()

		#self.word_list.Set(self.wordList)

	def openDic(self, dicpath):
		dicfile = open(dicpath, "r")

		if readdic.verifyDic(dicfile, "LDIC"):
			pass
		else:
			print u("̰ ùٸ   ƴմϴ.")
			exit

		list, l_offset_s, l_offset_e, mean, m_offset_s, m_offset_e, fnt, f_offset_s, f_offset_e = readdic.readHeader(dicfile, "cllcllcll")
		self.wordDic = readdic.makeWordlist(0, dicfile, l_offset_e)

		self.m_offset_s = m_offset_s

		for word in self.wordDic.keys():
			self.wordList.append(word)

		return dicfile

	def OnExit(self, e):
		self.Close(True)

	def OnOption(self, e):
		e.Skip()

	def OnRefresh(self, e):
		e.Skip()

	def OnAbout(self, e):
		d = wxMessageDialog(self, u(projectName + "  ldic wxPython ùԴϴ."), "About " + projectName, wxOK)
		d.ShowModal()
		d.Destroy()

	def OnText(self, e):
		word = self.word_text.GetValue()
		meaning = readdic.searchWord(self.dicfile, self.wordDic[word], self.m_offset_s)

		self.meaning_html.SetPage(meaning)
	
	def OnTextEnter(self, e):
		self.word_text.SetSelection(-1, -1)
	
app = wxPySimpleApp()
frame = MainWindow(None, -1, projectName)
app.MainLoop()
